<?php
if(!defined("WHMCS")) die("This file cannot be accessed directly");

class WebERP extends WBase
{
	private static $instance;
	protected $db;
	protected $api;
	protected $timeout=30;
	protected $ch;
	protected $error='';
	
	function __construct($db)
	{
		parent::__construct();
		$this->setDBconnection($db);
		$this->api=WAPI::getInstance($db);
	}
		
	function __destruct()
	{
		$this->close();
	}
	
	public static function getInstance($db=NULL)
	{
		if(!self::$instance) self::$instance = new self($db);
		return self::$instance;
	}
	
	protected function create()
	{
		$this->ch=curl_init();
	}
	
	protected function close()
	{
		if(is_resource($this->ch))
		{
			curl_close($this->ch);
			$this->ch=null;
		}
	}
	
	function getError()
	{
		return $this->error;
	}
	
	function callback($data,$close=true)
	{
		$config=$this->api->getConfig();
		$data['key']=md5($config['erpapi']);
		$url='https://'.$config['erpusername'].'.weberp.gr/callback.php';
		
		return $this->requestHelper($url,$data,$close); 
	}
	
	function request($data,$close=true)
	{
		$config=$this->api->getConfig();
		$url='https://'.$config['erpusername'].'.weberp.gr/api.php';
		$data['key']=substr(md5($config['erpapi'].parse_url($url, PHP_URL_HOST).date('Y')),0,24);
		
		return $this->requestHelper($url,$data,$close);
	}
	
	protected function requestHelper($url,$data,$close=true)
	{
		$config=$this->api->getConfig();

		if(empty($config['erpusername'])) return array('result'=>0,'error'=>'Username is empty');
		if(empty($config['erpapi'])) return array('result'=>0,'error'=>'API Key is empty');
		
		$user_agent=!empty($_SERVER['HTTP_USER_AGENT'])?$_SERVER['HTTP_USER_AGENT']:'Mozilla/5.0 (WebERP v1.0)';
		if($config['erpsiteid']) $data['siteid']=$config['erpsiteid'];
		$data['domain']=str_replace('www.','',$this->api->getHost());
		
		if(!$this->ch) $this->create();
		$this->error='';
		curl_setopt($this->ch, CURLOPT_URL, $url);
		curl_setopt($this->ch, CURLOPT_USERAGENT,$user_agent);
		curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, false );
		curl_setopt($this->ch, CURLOPT_ENCODING,'');
		curl_setopt($this->ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		curl_setopt($this->ch, CURLOPT_TIMEOUT, 90);
		curl_setopt($this->ch, CURLOPT_POST, 1);
		curl_setopt($this->ch, CURLOPT_POSTFIELDS,$data);
		$rsp=curl_exec($this->ch);
		$code=curl_getinfo($this->ch,CURLINFO_HTTP_CODE);
		$errorNo=curl_errno($this->ch);
		$this->error=curl_error($this->ch);
		if($close) $this->close();

		if($code>204 || $errorNo>0)
		{
			return array('result'=>0,'error'=>'Error:'.$this->error,'raw'=>$rsp);
		}
		
		return $this->api->JSONdecode(trim($rsp),true);
	}
	
	function downloadInvoice($id,$storePath,$close=true)
	{
		$this->error='';
		$config=$this->api->getConfig();

		if(empty($config['erpusername'])) return array('result'=>0,'error'=>'Username is empty');
		if(empty($config['erpapi'])) return array('result'=>0,'error'=>'API Key is empty');
		
		$user_agent=!empty($_SERVER['HTTP_USER_AGENT'])?$_SERVER['HTTP_USER_AGENT']:'Mozilla/5.0 (WebERP v1.0)';
		$url='https://'.$config['erpusername'].'.weberp.gr/api.php';
		$data['key']=substr(md5($config['erpapi'].parse_url($url, PHP_URL_HOST).date('Y')),0,24);
		if($config['erpsiteid']) $data['siteid']=$config['erpsiteid'];
		$data['task']='erp.download';
		$data['type']='invoice';
		$data['id']=$id;	
		
		if(!$this->ch) $this->create();
		curl_setopt($this->ch, CURLOPT_URL, $url);
		curl_setopt($this->ch, CURLOPT_USERAGENT,$user_agent);
		curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, false );
		curl_setopt($this->ch, CURLOPT_BINARYTRANSFER, true );
		curl_setopt($this->ch, CURLOPT_ENCODING,'');
		curl_setopt($this->ch, CURLOPT_CONNECTTIMEOUT, 30);
		curl_setopt($this->ch, CURLOPT_TIMEOUT, $this->timeout);
		curl_setopt($this->ch, CURLOPT_POST, 1);
		curl_setopt($this->ch, CURLOPT_POSTFIELDS,$data);
		$fileData=curl_exec($this->ch);
		$code=curl_getinfo($this->ch,CURLINFO_HTTP_CODE);
		$errorNo=curl_errno($this->ch);
		$this->error=curl_error($this->ch);
		if($close) $this->close();
				
		if(!$errorNo && in_array($code,array('200','201','202')) && !empty($fileData) && $this->api->writeFile($storePath,$fileData))
		{
			return array('result'=>1,'code'=>$code);
		}
		return array('result'=>0,'error'=>$this->error,'code'=>$code,'rawData'=>$fileData);
	}
}