<?php
if (!defined("WHMCS"))	die("This file cannot be accessed directly");
if(!defined('WEBERP_ROOT')) define('WEBERP_ROOT',ROOTDIR."/modules/addons/weberp");

function webERP_client($vars)
{
	require (WEBERP_ROOT.'/function.php');

	$config=$api->getConfig();
	$ignorePayments=array();
	foreach($config['payments'] as $payment=>$mode)
	{
		if($mode=='ignore')
		{
			$ignorePayments[]=$payment;
		}
	}

	if(!$config['startfrom'] || !$api->isDateValid($config['startfrom'])) $config['startfrom']=$api->dateSQL('-3 months');

	$filter=array();
	$filter[]='i.`userid`>='.$db->quoteValue($vars['userid']);
	$filter[]='i.`subtotal` >0';
	$filter['status']='i.`status` IN ("Paid")';
	$filter[]='i.`datepaid`>='.$db->quoteValue($config['startfrom']);
	
	if(count($ignorePayments)) $filter[]='i.`paymentmethod` NOT IN ('.$db->quoteArray($ignorePayments).')';
	$filter['existing']='i.`id` NOT IN (SELECT whmcsid FROM `mod_weberp_invoices`)';
	$filter['ignored']='i.`id` NOT IN (SELECT id FROM `mod_weberp_ignored`)';
	$rs=$db->query('SELECT c.*,i.* FROM `tblinvoices` as i LEFT JOIN `tblclients` as c ON i.userid=c.id WHERE '.implode(' AND ',$filter).' ORDER BY `datepaid` ASC');

	$data=array();
	while($row=$db->fetch_array($rs))
	{
		$invoice=$api->invoiceFormat($row);
		if(is_array($invoice) && !$invoice['ignored']) $data[$row['id']]=$invoice;
	}
	
	if(empty($data)) return;
	
	$erp=WebERP::getInstance($db);
	$request=array();
	$request['task']='GetInvoices';
	$request['result']=1;
	$request['data']=$data;
	$rsp=$erp->callback($request);
}

function webERP_InvoiceChange($vars)
{
	require (WEBERP_ROOT.'/function.php');

	$config=$api->getConfig();

	if(empty($config['erpusername']) || empty($config['erpapi'])) return;
	
	$row=$db->getRow('SELECT c.*,i.* FROM `tblinvoices` as i LEFT JOIN `tblclients` as c ON i.userid=c.id WHERE i.`id`='.$db->quoteValue($vars['invoiceid']).';');
	if(empty($row)) return;

	$invoice=$api->invoiceFormat($row);
	if(!is_array($invoice) || $invoice['ignored']) return;
		
	$erp=WebERP::getInstance($db);
	$request=array();
	$request['task']='GetInvoices';
	$request['result']=1;
	$request['data'][$row['id']]=$invoice;
	$rsp=$erp->callback($request);
}

function webERP_InvoiceMeMenu($Navbar)
{
	global $_LANG;
	$menuTitle=Lang::trans('WEBERP_MENU_INVOICES');
	$isVisitor = is_null(Menu::context('client'));
	$theMenu = $Navbar->getChild('Billing');
	
	if(is_object($theMenu) && !$isVisitor)
	{
		require (WEBERP_ROOT.'/function.php');
		
		if(empty($menuTitle) || strtoupper($menuTitle)=='WEBERP_MENU_INVOICES')
		{
			$menuTitle=$api->getLang('WEBERP_MY_INVOICES',true);
		}
		
		$theMenu->addChild(
			'weberp',
				array(
				  'name' => 'weberpinvoices',
				   'label' => $menuTitle,
				   'uri' => 'index.php?m=weberp',
				   'order' => 120,
				   'icon' => '', //fa fa-file fa-file-pdf-o
				)
		);
	}
}

add_hook('ClientAreaPrimaryNavbar',101,'webERP_InvoiceMeMenu');
//add_hook("ClientAdd",100,"webERP_client");
add_hook("ClientEdit",100,"webERP_client");
add_hook("InvoicePaid",100,"webERP_InvoiceChange");
add_hook("InvoiceUnpaid",100,"webERP_InvoiceChange");
add_hook("InvoiceRefunded",100,"webERP_InvoiceChange");
add_hook("InvoiceCancelled",100,"webERP_InvoiceChange");
//add_hook("UpdateInvoiceTotal",100,"webERP_InvoiceChangeTotal");