<?php 
if(!defined("WHMCS")) die("This file cannot be accessed directly");
if(!defined('WEBERP_ROOT')) define('WEBERP_ROOT',ROOTDIR."/modules/addons/weberp");
error_reporting(E_ALL);

function weberp_config()
{
    $configarray = array(
		"name" => "WebERP.gr Integration",
		"description" => "WebERP invoicing",
		"version" => '1.0.4',
		"author" => "Web-expert.gr",
		"language" => "english",
		"fields" => array(
			"deletetables" => array ("FriendlyName" => "Remove Tables", "Type" => "yesno", "Size" => "25", "Description" => "Remove tables after deactivation", "Default" => "", ),
		),
	);
	
    return $configarray;
}

function weberp_activate()
{
	define('INSTALLED_WEBERP',true);
	require (WEBERP_ROOT.'/function.php');
	$db->source_query(WEBERP_ROOT.'/assets/sql/install.sql');
    return array('status'=>'success','description'=>'Successfully Activated');
}

function weberp_deactivate()
{
	require (WEBERP_ROOT.'/function.php');
		
	$delete=$api->getModuleParams('deletetables');
	if($delete!='on')
	{
		return array('status'=>'info','description'=>'For completely un-installation drop tables manually with prefix "mod_weberp_"');
	}
	$db->display_errors(true);
	$db->query('DROP TABLE IF EXISTS `mod_weberp_config`;');
	$db->query('DROP TABLE IF EXISTS `mod_weberp_invoices`;');
	
    return array('status'=>'success','description'=>'Module uninstalled completely!');
}

function weberp_upgrade($vars)
{
	if(defined('INSTALLED_WEBERP')) return;

	require (WEBERP_ROOT.'/function.php');
	$db->display_errors(true);
	
	$db->source_query(WEBERP_ROOT.'/assets/sql/install.sql');
	$api->deleteFolder(WEBERP_ROOT.'/sql',true); //old folder
	
	if(version_compare($vars['version'],'1.0.2','lt'))
	{
		$cols=$db->getColumns('mod_weberp_invoices');
		if(!array_key_exists('whmcsid',$cols)) $db->query('ALTER TABLE `mod_weberp_invoices` ADD `whmcsid` INT UNSIGNED NOT NULL AFTER `id`;');
		$db->query('UPDATE `mod_weberp_invoices` SET `whmcsid`=`id`;');
		$datas=$db->getArray('SELECT * FROM `mod_weberp_invoices`');
		
		$db->query('ALTER TABLE `mod_weberp_invoices` CHANGE `id` `id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT;');
		$db->query('ALTER TABLE `mod_weberp_invoices` AUTO_INCREMENT=1;');
		$db->query('TRUNCATE TABLE `mod_weberp_invoices`;');
		
		$db->query('ALTER TABLE `mod_weberp_invoices` DROP INDEX `userid`;');
		$db->query('ALTER TABLE `mod_weberp_invoices` DROP INDEX `whmcs_erp`;');

		$db->query('ALTER TABLE `mod_weberp_invoices` ADD UNIQUE `whmcs_erp` (`whmcsid`, `invoiceid`);');
		$db->query('ALTER TABLE `mod_weberp_invoices` ADD INDEX `userid` (`userid`);');
		
		foreach($datas as $data)
		{
			unset($data['id']);
			$db->insert('mod_weberp_invoices',$data);
		}
	}
}

function weberp_output($vars)
{
	require (WEBERP_ROOT.'/function.php');
	
	$CMD=$api->getWord('cmd','invoices');
	define('MODULE_LINK','addonmodules.php?module=weberp');
	$config=$api->getConfig();
	if(isset($config['language']) && $config['language']) $api->getLang('',true,$config['language']);
	
	$body='Not found...';
	if($api->file_exists(WEBERP_ROOT.'/pages/'.$CMD.'.php'))
	{
		ob_start();
		require_once(WEBERP_ROOT.'/pages/'.$CMD.'.php');
		$body=ob_get_clean();
	}
		
	ob_start();
	require_once(WEBERP_ROOT.'/layouts/header.php');
	require_once(WEBERP_ROOT.'/layouts/body.php');
	require_once(WEBERP_ROOT.'/layouts/footer.php');
	echo ob_get_clean();
}

function weberp_clientarea($vars)
{
	$debug=0;
	require (WEBERP_ROOT.'/function.php');
	$CMD=$api->getWord('cmd','');
	$key=$api->getCmd('key','',$debug?'REQUEST':'POST');
	if($api->getInt('api',0,$debug?'REQUEST':'POST') && $CMD)
	{
		$config=$api->getConfig();
		$rsp=array('result'=>0,'error'=>'not found');
		if($config['whmcskey'] && $key==$config['whmcskey'] && $api->file_exists(WEBERP_ROOT.'/apis/'.$CMD.'.php'))
		{
			$rsp=array();
			require_once(WEBERP_ROOT.'/apis/'.$CMD.'.php');
		}
		else if($key!=$config['whmcskey'])
		{
			$rsp['error']='Invalid Key';
		}
		else
		{
			$rsp['error']='Command does not exists';
		}
		$api->printJSON($rsp);
	}
	
	$LANG=$vars['_lang'];
	$userID=(int)$_SESSION["uid"];
	
	if($userID && $CMD=='download' && $api->file_exists(WEBERP_ROOT.'/pages/'.$CMD.'.php'))
	{
		require_once(WEBERP_ROOT.'/pages/'.$CMD.'.php');
		exit();
	}
	
	$smartyvalues=array();
	$smartyvalues["userid"]=$userID;
	$smartyvalues["invoices"]=array();
	$limit=$api->getInt('limit',50);
	
	if($limit>100) 
		$limit=100;
	elseif($limit<10)
		$limit=10;
	
	$p=$api->getInt('p',1);
	if($p<1) $p=1;
	
	$smartyvalues["limit"]=$limit;
	$smartyvalues["p"]=$p;
	$smartyvalues["pagination"]=array();
	$smartyvalues["modulelink"]=$vars['modulelink'];
	$smartyvalues["ADDONLANG"]=$LANG;
	$smartyvalues["invoicetypes"]=array();
	$smartyvalues["invoiceme"]=$api->folder_exists(ROOTDIR.'/modules/addons/invoiceme');
	
	if($userID>0)
	{
		$file=$api->readFile(WEBERP_ROOT.'/invoicetypes.json');
		if($file!='') $smartyvalues["invoicetypes"]=json_decode($file,true);
		
		$date=$api->getString('date','');	
		
		$filters=array();
		$filters[]='`userid`='.$db->quoteValue($userID);
		if($date && $api->isDateValid($date)) $filters[]='`invoicedate`='.$db->quoteValue($api->dateSQL($date));
		
		$smartyvalues["total_results"]=$db->getValue('SELECT count(*) FROM mod_weberp_invoices WHERE '.implode(" AND ",$filters));;
		$totalPages=ceil($smartyvalues["total_results"]/$limit);
		
		$start = ($p-1)*$limit;
		$rs=$db->query('SELECT * FROM mod_weberp_invoices WHERE '.implode(" AND ",$filters).' ORDER BY invoicedate desc LIMIT '.$start.','.$limit);
		$smartyvalues["total_page"]=$db->num_rows($rs);
		
		$mydpdfs=array();
		while($data=$db->fetch_array($rs))
		{
			$data["invoicedate"]=date('d/m/Y H:i',strtotime($data["invoicedate"]));
			$data["invoicetypename"]=isset($smartyvalues["invoicetypes"][$data["invoicetype"]])?$smartyvalues["invoicetypes"][$data["invoicetype"]]:'';
			$data["url"]=$vars['modulelink'].'&cmd=download&id='.$data['id'];
			$data["total"]=number_format($data["total"],2,',','.');
			$mydpdfs[$data["id"]]=(object)$data;
		}
		$smartyvalues["invoices"]=$mydpdfs;
		
		if($p>1 && $smartyvalues["total_results"]>$limit)
		{
			$smartyvalues["pagination"][-1]='<a href="index.php?m=weberp&p='.($p-1).'">'.$LANG['WEBERP_PAGINATION_PREVIΟUS'].' ('.($p-1).')</a>';
		}
		
		$smartyvalues["pagination"][1]='<a class="active" href="index.php?m=weberp&p='.$p.'">'.$LANG['WEBERP_PAGINATION_CURRENT'].' ('.$p.')</a>';
		
		if($smartyvalues["total_page"]>=$limit && ($p+1)<$totalPages)
		{
			$smartyvalues["pagination"][-2]='<a href="index.php?m=weberp&p='.($p+1).'">'.$LANG['WEBERP_PAGINATION_NEXT'].' ('.($p+1).')</a>';
		}
		
		if($totalPages>2 && $totalPages!=$p)
		{
			$smartyvalues["pagination"][-3]='<a href="index.php?m=weberp&p='.$totalPages.'">'.$LANG['WEBERP_PAGINATION_LAST'].' ('.($totalPages).')</a>';
		}
	}
	
    return array(
        'pagetitle' => $LANG['WEBERP_MY_INVOICES'],
        'breadcrumb' => array('index.php?m=weberp'=>$LANG['WEBERP_MY_INVOICES']),
        'templatefile' => 'weberpinvoices',
        'requirelogin' => true, # or false
        'vars' => $smartyvalues,
    );
}